//#include "../testlib/testlib.h"
#include "testlib.h"

using namespace std;
const int MAX_N = 100000;
vector<int> used;
vector<vector<int>> g;

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAX_N, "n");
    inf.readEoln();
    int sm = 0;
    g.assign(n, vector<int>());
    for (int i = 0; i < n; i++) {
        int k = inf.readInt(0, n, "k_i");
        sm += k;
        if (k > 0) {
            inf.readSpace();
            vector<int> slaves = inf.readInts(k, 1, n, "v_i_j");
            for (int u: slaves) {
                g[i].push_back(u - 1);
                g[u - 1].push_back(i);
            }
        }
        inf.readEoln();
    }
    ensuref(sm == n - 1, "not a tree");
    used.assign(n, 0);
    dfs(0);
    for (int i = 0; i < n; i++) {
        ensuref(used[i], "not a tree");
    }
    inf.readEof();
}