//
// Created by Daniil Oreshnikov on 01.11.2024.
//

#include "testlib.h"
#include <vector>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = opt<int>("n"), sw = opt<int>("sw");
    vector<int> a(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        a[i] = i < n ? i : i - n;
        a[i]++;
    }
    if (has_opt("rev") && opt<bool>("rev")) {
        reverse(a.begin() + n, a.end());
    }

    for (int i = 0; i < sw; i++) {
        int x = rnd.next(2 * n), y = rnd.next(2 * n);
        swap(a[x], a[y]);
    }

    println(n);
    println(a.begin(), a.end());

}