/*
Author: @doreshnikov
Created on: 01.11.2024/00:04
*/

#include <iostream>
#include <vector>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}

#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

pair<int, int> query(int x, int y) {
    cout << x + 1 << ' ' << y + 1 << '\n';
    cout.flush();
    in(int, vx, vy)
    return {vx - 1, vy - 1};
}

int main() {

    in(int, n, a, b)
    a--, b--;
    vector<int> pool;
    for (int i = 0; i < 2 * n; i++) {
        if (i != a && i != b) {
            pool.push_back(i);
        }
    }

    vector<int> known(n, -1);

    for (int i = 0; i < n - 1; i++) {
        int x = pool[2 * i], y = pool[2 * i + 1];
        auto [vx, vy] = query(x, y);

        if (vx == vy) continue;

        if (known[vx] != -1) {
            auto [c1, c2] = query(known[vx], x);
            if (c1 != c2) return 1;
            known[vx] = -1;
        } else {
            known[vx] = x;
        }

        if (known[vy] != -1) {
            auto [c1, c2] = query(known[vy], y);
            if (c1 != c2) return 1;
            known[vy] = -1;
        } else {
            known[vy] = y;
        }
    }

    vector<int> rem;
    for (int i = 0; i < n; i++) {
        if (known[i] != -1) rem.push_back(known[i]);
    }

    if (rem.empty()) {
        auto [c1, c2] = query(a, b);
        if (c1 != c2) return 1;
    } else {
        if (rem.size() != 2) return (int) rem.size();
        auto [c1, c2] = query(rem[0], a);
        if (c1 != c2) return 1;
        auto [c3, c4] = query(rem[1], b);
        if (c3 != c4) return 1;
    }

}