#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_p = opt<int>("p");
    int r = rnd.next(1, max_p);

    int x = rnd.next(-r, r);
    int max_y = (int) sqrt((double) r * r - (double) x * x);
    int y = rnd.next(-max_y, max_y);
    if (rnd.next(0, 1)) {
        swap(x, y);
    }

    println(r);
    println(x, y);

    return 0;
}
