#include <iostream>

using ll = long long;

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

void solve() {
    ll x, y, k;
    std::cin >> x >> y >> k;
    ll s = x + y;
    ll l = s - 1, r = s + 1;
    while (!is_prime(l)) {
        l--;
    }
    while (!is_prime(r)) {
        r++;
    }
    if (s - k <= l || s + k >= r) {
        std::cout << "Yes\n";
        return;
    }
    if ((r - s) % (k + 1) != 0) {
        std::cout << "Yes\n";
    } else {
        std::cout << "No\n";
    }
}

int main() {
    int tests;
    std::cin >> tests;
    while (tests--) {
        solve();
    }
}
