using namespace std;

#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

using ll = long long;
const ll MOD = 1000000007;

ll modsum(ll a, ll b) {
    return (a + b) % MOD;
}

int main() {
    fastio;

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<ll> left(n, 1), right(n, 1);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (a[j] < a[i]) {
                left[i] = modsum(left[i], left[j]);
            }
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        for (int j = n - 1; j > i; --j) {
            if (a[j] < a[i]) {
                right[i] = modsum(right[i], right[j]);
            }
        }
    }

    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = modsum(ans, left[i] * right[i]);
//        cout << leftg[i] << " " << rightg[i] << "\n";
    }
    cout << ans << "\n";
//    cout << "\n";
//    cout << "\n";

    //    cout << "! " << x << " " << y << "\n";
}