#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
    int n; cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    sort(v.begin(), v.end());
    v.insert(v.begin(), v.back());
    v.pop_back();

    int cur = 0;
    vector<int> mexes;
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cnt[v[i]]++;
        while (cnt[cur]) cur++;
        mexes.push_back(cur);
    }

    sort(mexes.begin(), mexes.end());
    int i = 0, res = 0;
    while (true) {
        bool found = false;
        while (i < mexes.size() && mexes[i] == res) {
            found = true;
            i++;
        }
        if (found) {
            res++;
            continue;
        }
        cout << res << '\n';
        return 0;
    }
}