#include <deque>
#include <vector>
#include <iostream>
#include <algorithm>
#include <unordered_set>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}

#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);
#define all(c) c.begin(), c.end()

int const MAX_A = 100'000;

int main() {

    in(int, n)
    vector<int> cnt(MAX_A + 1);
    for (int i = 0; i < n; i++) {
        in(int, x)
        cnt[x]++;
    }

    deque<pair<int, int>> values;
    for (int i = 1; i <= MAX_A; i++) {
        if (cnt[i]) values.emplace_back(i, cnt[i]);
    }

    long long steps = 0;
    while (values.size() > 2) {
        auto mn = values.front(), mx = values.back();
        values.pop_front(); values.pop_back();

        if (mn.second <= mx.second) {
            values.front().second += mn.second;
            mx.second -= mn.second - 1;
            values.back().second += mn.second - 1;
            steps += 2 * mn.second - 1;

            if (values.size() == 1) {
                values.push_back(mx);
                break;
            }

            mx.second--;
            values.back().second++;
            steps++;

            if (mx.second != 0) values.push_back(mx);
        } else {
            mn.second -= mx.second;
            values.front().second += mx.second;
            values.back().second += mx.second;
            values.push_front(mn);

            steps += 2 * mx.second;
        }
    }

    cout << steps << '\n';
    cout << values.front().first << ' ' << values.back().first << '\n';

}