#include <deque>
#include <vector>
#include <iostream>
#include <map>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}

#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);
#define all(c) c.begin(), c.end()

int const MAX_A = 100'000;

int main() {

    in(int, n)
    vector<int> a(n);
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i]]++;
    }

    long long steps = 0;
    while (cnt.size() > 2) {
        auto p = *cnt.begin();
        cnt.erase(cnt.begin());
        steps++;

        cnt.begin()->second++;
        if (--p.second > 0) {
            cnt[p.first] = p.second;
        }
        if (cnt.size() <= 2) break;

        auto q = *cnt.rbegin();
        cnt.erase(--cnt.end());
        steps++;

        cnt.rbegin()->second++;
        if (--q.second > 0) {
            cnt[q.first] = q.second;
        }
    }

    cout << steps << '\n';
    cout << cnt.begin()->first << ' ' << cnt.rbegin()->first << '\n';

}