#include <iostream>
#include <vector>
#include <queue>
#include <cassert>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,popcnt")

using std::cin;
using std::vector;
using std::queue;
using std::cout;

int main() {
    int n, q;
    cin >> n >> q;
    vector<queue<int>> a(1);
    int x;
    for (int i = 0; i < n; i++) {
        cin >> x;
        a[0].push(x);
    }
    while (q--) {
        std::string req;
        cin >> req;
        if (req == "push") {
            cin >> x;
            if (a.size() == 0) a.emplace_back();
            a.back().push(x);
        } else if (req == "pop") {
            cout << a[0].front() << '\n';
            for (int i = a.size() - 1; i >= 0; i--) {
                a[i].pop();
                if (a[i].empty()) {
                    a.erase(a.begin() + i);
                }
            }
        } else if (req == "cut") {
            int i, j;
            cin >> i >> j;
            i--;
            a.insert(a.begin() + i, queue<int>());
            while (j--) {
                a[i].push(a[i + 1].front());
                a[i + 1].pop();
            }
        } else if (req == "restore") {
            queue<int> cur;
            int bebra = 0;
            for (auto &i: a) {
                while (!i.empty()) {
                    bebra++;
                    cur.push(i.front());
                    i.pop();
                }
            }
            a.clear();
            a.push_back(cur);
        } else {
            assert(false);
        }
    }
}
