#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

string get_str(int len, vector<char>& let) {
    string ans;
    for (int i = 0; i < len; ++i) {
        ans.push_back(let[rnd.next(0, (int)let.size() - 1)]);
    }
    return ans;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = has_opt("n") ? opt<int>("n") : 200'000;
    int m = has_opt("m") ? opt<int>("m") : 200'000;
    int letters = has_opt("letters") ? opt<int>("letters") : 26;
    int max_len = has_opt("max_len") ? opt<int>("max_len") : 1000'000;
    const int LEN = 1000'000;

    vector<char> let(letters);
    iota(let.begin(), let.end(), 'a');

    println(n, m);

    int sum_len = LEN;
    for (int i = 0; i < n; ++i) {
        int can_len = min(sum_len - (n - i - 1), max_len);
        int len = rnd.next(1, can_len);

        println(get_str(len, let));
        sum_len -= len;
    }

    sum_len = LEN;
    for (int i = 0; i < m; ++i) {
        int can_len = min(sum_len - (m - i - 1), max_len);
        int len = rnd.next(1, can_len);

        println(get_str(len, let));
        sum_len -= len;
    }
}
