using namespace std;

#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

using ll = long long;
const ll MOD = 1000000007;

ll modsum(ll a, ll b) {
    return (a + b) % MOD;
}

int main() {
    fastio;

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll p = (ll) 1 << (ll) n;

    ll ans = 0;
    for (ll m = 1; m < p; ++m) {
        int mode = 0;
        bool ok = true;
        int prev = -1;
        for (int i = 0; i < n; ++i) {
            if ((m & (1 << i)) == 0) {
                continue;
            }
            if (mode == 0) {
                if (prev == -1) { prev = a[i]; continue; }
                else if (prev < a[i]) { prev = a[i]; continue; }
                else if (prev > a[i]) { mode = 1; prev = a[i]; }
                else { ok = false; break; }
            } else {
                if (prev > a[i]) { prev = a[i]; continue; }
                else { ok = false; break; }
            }
        }
        if (ok) {
            ++ans;
        }
    }

    cout << ans << "\n";
}