#include <bits/stdc++.h>

#define int long long
#define pb emplace_back
#define mp make_pair
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(time(nullptr));

const int inf = 1e9;
const int M = 1e9 + 7;
const ld pi = atan2(0, -1);
const ld eps = 1e-6;

void dfs(int v, int p, vector<vector<int>> &sl, vector<int> &sz, vector<int> &eul, vector<int> &a){
    for(int u: sl[v]){
        if(u == p) continue;
        dfs(u, v, sl, sz, eul, a);
        a[v] += a[u];
        sz[v] += sz[u];
    }
    eul.emplace_back(v);
}

void solve(int tc){
    int n, w;
    cin >> n >> w;
    vector<int> a(n);
    for(int &e: a) cin >> e;
    vector<vector<int>> sl(n);
    for(int i = 1; i < n; ++i){
        int u, v;
        cin >> u >> v;
        sl[--u].emplace_back(--v);
        sl[v].emplace_back(u);
    }

    vector<int> sz(n, 1), order;
    dfs(0, 0, sl, sz, order, a);

    vector<vector<bool>> dp(n, vector<bool>(w + 1));
    dp[0][0] = true;
    if(a[order[0]] <= w) {
        dp[0][a[order[0]]] = true;
    }
    for(int i = 1; i < n; ++i){
        for(int j = 0; j <= w; ++j){
            dp[i][j] = dp[i - 1][j];
        }

        int p = i - sz[order[i]], ww = a[order[i]];
        if(p == -1){
            if (ww <= w) {
                dp[i][ww] = true;
            }
        }
        else{
            for(int j = 0; j + ww <= w; ++j){
                if (!dp[p][j]) continue;
                dp[i][j + ww] = true;
            }
        }
    }

    if(!dp[n - 1][w]){
        cout << -1;
        return;
    }

    vector<int> ans;
    int i = n - 1, j = w;
    while (j > 0) {
        int p = i - sz[order[i]], ww = a[order[i]];
        if(ww > j){
            i--;
            continue;
        }
        if(p == -1){
            if(ww == j){
                ans.push_back(order[i] + 1);
                break;
            }
            i--;
            continue;
        }
        if(dp[p][j - ww]){
            ans.push_back(order[i] + 1);
            i = p;
            j -= ww;
        }
        else{
            i--;
        }
    }
    cout << ans.size() << "\n";
    for(int e: ans) cout << e << " ";
}

bool multi = false;

signed main() {
    int t = 1;
    if (multi)cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << "\n";
    }
    return 0;
}
